#! /usr/bin/env python
#-*- coding:utf-8 -*-
import datetime
import hashlib
import hmac
import re
import urllib
import uuid
import sys
import string
import termios
import tty
import select
import signal
import json
import errno
import struct
import fcntl
import tarfile
import zipfile
import os
import time
import glob

currentpwd = ""
packagepath = ""
packagezip = ""
pluginpath = ""

def isRunning(process_name):
   # print process_name
    try:
        process = len(os.popen('/bin/ps aux | grep "' + process_name + '" | grep -v grep').readlines())
        if process >= 1:
            return True
        else:
            return False
    except:
        print("Check process ERROR!!!")
        return False
      
def uninstall(path1):  
    fileList=os.listdir(path1)  
    for file in fileList:  
        mypath=os.path.join(path1,file) 
        if os.path.isdir(mypath):  
           uninstall(mypath)    
        else:  
            if mypath.find('uninstall.sh') > 0:
                os.system('%s' % mypath)
            
def un_zip(file_name):  
    """unzip zip file"""  
    zip_file = zipfile.ZipFile(file_name)
    filepath = file_name.rstrip('.zip')
    global packagepath 
    packagepath= filepath
    print  filepath
    if os.path.isdir(packagepath):
        pass  
    else:  
        os.mkdir(packagepath)
    for names in zip_file.namelist():
        zip_file.extract(names,packagepath)
    zip_file.close()
    
def extract(tar_path, target_path):  
    try:  
        tar = tarfile.open(tar_path, "r:gz")  
        file_names = tar.getnames()  
        for file_name in file_names:  
            tar.extract(file_name, target_path)
        tar.close()  
    except Exception, e:  
        raise Exception, e  

def deploy_install():
    global packagezip
    global pluginpath

    isrunning = isRunning("JCSAgentCore")
    if isrunning == True:
        print 'Have a JCSAgentCore running, if we need exec install, we should exec uninstall firstly !!!'
        sys.exit(2)
    print  'Start install instance data ！！！'
    un_zip(packagezip)
    jsonfile = packagepath + "/reserved.json"
    f = file(jsonfile,'r+')
    s=json.load(f)
    CoreFlag=s['Core']
    MoniFlag=s['MonitorPlugin']
    ScriptFlag=s['Scripts']
    UpagradeFlag=s['UpgradePlugin']
   # print CoreFlag,MoniFlag,ScriptFlag,UpagradeFlag
    f.close()
    md5path = "/usr/local/share/jcloud/agent/upgrade/md5"
    reservedpath = "/usr/local/share/jcloud/agent/upgrade/reserved"
    if os.path.isdir(md5path):
        pass  
    else:  
        os.makedirs(md5path)
        os.makedirs(reservedpath)
    for lists in os.listdir(packagepath): 
        filepath = os.path.join(packagepath, lists) 
        if filepath.endswith('.tar.gz'):
            pluginpath = filepath.rstrip('.tar.gz')
            extract(filepath, pluginpath)
            command = "/bin/bash " + pluginpath + "/install.sh"
            os.system('cd  %s && %s' %(pluginpath,command))
            if pluginpath.find('Core') > 0:
                if CoreFlag == True:
                    os.system('cp %s /usr/local/share/jcloud/agent/upgrade/reserved/Core' % filepath)
		if os.path.exists("/usr/local/share/jcloud/jcs_agent_bakup/core/conf"):
                    os.system('\cp -R /usr/local/share/jcloud/jcs_agent_bakup/core/conf /usr/local/share/jcloud/agent/')
                os.system('md5sum  %s |awk \'{print $1}\' > /usr/local/share/jcloud/agent/upgrade/md5/Core' % filepath)
            elif pluginpath.find('monitor') > 0:
                if MoniFlag == True:
                    os.system('cp %s /usr/local/share/jcloud/agent/upgrade/reserved/MonitorPlugin' % filepath)
                MonitorPlug =  glob.glob(r'/usr/local/share/jcloud/agent/plugins/MonitorPlugin*')[0]
		if os.path.exists("/usr/local/share/jcloud/jcs_agent_bakup/monitor/monitor.cfg"):
                    os.system('\cp /usr/local/share/jcloud/jcs_agent_bakup/monitor/monitor.cfg %s/' % MonitorPlug)
		if os.path.exists("/usr/local/share/jcloud/jcs_agent_bakup/monitor/Extended.cfg"):
                    os.system('\cp /usr/local/share/jcloud/jcs_agent_bakup/monitor/Extended.cfg %s/' % MonitorPlug)
                os.system('md5sum  %s |awk \'{print $1}\' > /usr/local/share/jcloud/agent/upgrade/md5/MonitorPlugin' % filepath)
            elif pluginpath.find('script') > 0:
                if ScriptFlag == True:
                    os.system('cp %s /usr/local/share/jcloud/agent/upgrade/reserved/Scripts' % filepath)
		if os.path.exists("/usr/local/share/jcloud/jcs_agent_bakup/scripts/initConfig.json"):
                    os.system('\cp /usr/local/share/jcloud/jcs_agent_bakup/scripts/initConfig.json /usr/local/share/jcloud/agent/scripts/linux/config/')
                os.system('md5sum  %s |awk \'{print $1}\' > /usr/local/share/jcloud/agent/upgrade/md5/Scripts' % filepath)
            elif pluginpath.find('upgrade') > 0:
                if UpagradeFlag == True:
                    os.system('cp %s /usr/local/share/jcloud/agent/upgrade/reserved/UpgradePlugin' % filepath)
                os.system('md5sum  %s |awk \'{print $1}\' > /usr/local/share/jcloud/agent/upgrade/md5/UpgradePlugin' % filepath)
    os.system('rm -rf %s' % packagepath)
    print 'Installation completed.'
    instanceid = os.popen('curl -X GET "http://169.254.169.254/jcs-metadata/latest/instance-id"').readlines()
    instanceid = ''.join(instanceid)
    instanceid = instanceid.strip().strip('"')
    os.system('mkdir -p /var/lib/jcloud/instances/%s/sem/' % instanceid)
    os.system('date "+%%Y-%%m-%%d %%H:%%M:%%S" > /var/lib/jcloud/instances/%s/sem/entry-runtag' % instanceid)
    os.system('rm -rf /var/lib/jcloud/instance')
    os.system('ln -s /var/lib/jcloud/instances/%s /var/lib/jcloud/instance' % instanceid)
    print 'entry file created'

    sys.exit(0)
    
def deploy_uninstall():
    print 'Backup Configuration File ...'
    os.system('mkdir -p /usr/local/share/jcloud/jcs_agent_bakup/monitor')
    MonitorPlug = glob.glob(r'/usr/local/share/jcloud/agent/plugins/MonitorPlugin*')[0]
    os.system('\cp %s/monitor.cfg /usr/local/share/jcloud/jcs_agent_bakup/monitor/' % MonitorPlug)
    os.system('\cp %s/Extended.cfg /usr/local/share/jcloud/jcs_agent_bakup/monitor/' % MonitorPlug)
    os.system('mkdir -p /usr/local/share/jcloud/jcs_agent_bakup/scripts')
    os.system('\cp /usr/local/share/jcloud/agent/scripts/linux/config/initConfig.json /usr/local/share/jcloud/jcs_agent_bakup/scripts/')    
    os.system('mkdir -p /usr/local/share/jcloud/jcs_agent_bakup/core/conf')
    os.system('\cp -R /usr/local/share/jcloud/agent/conf/JCSAgentCore.json /usr/local/share/jcloud/jcs_agent_bakup/core/conf/')
    uninstall('/usr/local/share/jcloud/agent')
    print 'rm -rf /usr/local/share/jcloud/agent/*'
    os.system('rm -rf /usr/local/share/jcloud/agent/*')
    print 'rm -fr /var/lib/jcloud/*'
    os.system('rm -fr /var/lib/jcloud/*')
    sys.exit(0)


if __name__ == "__main__":
    if len(sys.argv) < 2:
        print 'Warning: Please enter the parameters：1.install;2.uninstall'
        sys.exit(1)
    args = sys.argv[1]
    currentpwd = os.getcwd()  + "/" 
    packagezip = currentpwd+"jcloud-jcs-agent-linux.zip"

    if args == 'install':
        deploy_install()
    elif args == 'uninstall':
        deploy_uninstall()
    else:
	print 'Warning: Unknown the parameter: %s' % args
	print 'Please enter the parameters：1.install; 2.uninstall'
    
    sys.exit(0)
	#main()
